$PAGEWIDTH=120
;*********************************************************************
;           
;        +  (  0.01  07-01-2011)
;    V 0.06 			                       22-01-2011 
;---------------------------------------------------------------------


;*********************************************************************
;
        DefSeg  All,Absolute
        Seg     All
;
;=========================================================
;                
;=========================================================
Reg0	equ		0	;R0
Reg1	equ		1	;R1
Reg4	equ		4	;R4
Steck   equ     	7       ; 

Reg_VD	equ		24h 	;   (1-,2-,-)

mT50	equ		29h	;  50
mSP1	equ		2Ah	; 1 (  )
mSout	equ		2Bh	;   50

PTA		equ	2Ch	;
PTB		equ	2Dh	;
iBufRs		equ  	2Eh	;   ..
oBufRs		equ	2Fh	; .  .

BufRs		equ	30h	;  (  )
BufRsLng    	equ	24	; 

Cnl_Period	equ	50h	;     (0FFh=6s,..,0Fh=400ms,..,1=50ms)
Cnl_Povtor	equ	51h	;       (0 -  )
Cnl_BufLng	equ	52h	;    
Cnl_BufSt	equ	53h	;     
Cnl_Bufer	equ	55h	;     

;=========================================================
;                
;=========================================================
bWork		equ	20h.1	;1 -  , 0 - 
bTxRdy		equ	20h.2	;   
KeyOld		equ	20h.5	;   

;=========================================================

;R0 -    
;R1 -      .
;R2 -  (    )
;R3 -  50
;R4 -  50
;R5 -  ()   50
;R6 -       
;R7 -    SIM

;=========================================================
;              / 
;=========================================================

Kontr0	equ	P0.2	; (0-) -    !

;               P3.0    ;RxD - in    60
;               P3.1    ;TxD - out   60

Switch	equ	P3.2	;  (=1 / =0)
KeyPin	equ	P3.2	;   -  
Kontr	equ	P3.3	; (1-)

Cnl_0	equ	P2.0	;  0
Cnl_1	equ	P2.1	;  1
Cnl_2	equ	P2.2	;  2
Cnl_3	equ	P2.3	;  3

;=========================================================
;                      
;=========================================================

        ORG     0
        LJMP    Begin
;
;	ORG	3		;   INT0
;	
        db      ' grl006 '	; 
;
        ORG     0BH             ;Timer counter TF0 Interrapt
        LJMP    TimInt
;
        ORG     13H             ;pp  INT1 
        reti
;
        ORG     1BH             ;Timer counter TF1 Interrapt
        ljmp	Time50

        ORG     23H             ;  . 
        ljmp	Serial
;
sCPBR1:	db	'AT+CPBR=1',0Dh,0    	;   1 . 
sCPBR2:	db	'AT+CPBR=2',0Dh,0    	;   2 . 
sCPBR3:	db	'AT+CPBR=3',0Dh,0    	;   3 . 
sCPBRX:	db	'AT+CPBR=',0         	;   c   
sATZ:	db	'ATZ',0Dh,0	     	; ATZ
sATE0:	db	'ATE0',0Dh,0	     	; -
sATCM:	db	'AT+CMEC=2',0Dh,0    	;  
sATCK:	db	'AT+CKPD=',0	     	;   
sATER:	db	'AT+CMER=3,2,0,0,0',0Dh,0    ;   
sATH:	db	'ATH',0Dh,0     	; " " ()

AdrOK:		db	'OK',0		;   
AdrErr:		db	'ERROR',0	;   ERROR ()
AdrStar:	db	'*',0		;      ("*")
AdrEqul:	db	'=',0		;      ("=")
AdrTire:	db	'-',0		;  ( )    ("-")
AdrEnd:		db	'.',0		;      (".")
AdrRING: 	db	'RING',0	;  " "

s_1:	db	'#1',0		;    "#1" 
s_2:	db	'#2',0		;    "#2" 
s2st:	db	'*006*',0	;     "**"

;**********************************************
;       T/C1 (50 )
;**********************************************
Time50:	
;	cjne	R5,#0,t50_1
;	reti
;t50_1:	dec	R5		;  50 
	reti
		
;**********************************************
;       T/C0 (25 )
;**********************************************
TimInt: push    ACC
        push    PSW

        MOV     TH0,#8BH    	;  T/C0 = 25
        MOV     TL0,#7AH    	;25 ms  (8B7Ah)  14,31818
                            	;    
	mov	A,PTA		; 
	jz	ti01		; - 
	dec	PTA		; -1  25
ti01:
	dec	PTB		; (50,100,200,400,800,1.6c,3.2c,6.4c)

;  
	mov	A,Reg_VD
	dec	A
	jnz	ti02
	clr	C		;   (1)
	cpl	C
	ajmp	ti04
ti02:	dec	A
	jnz	ti03
	clr	C		;   (2)
	ajmp	ti04
ti03:	mov	A,PTB
	mov	C,ACC.3		; 
	jnb	Switch,ti04
	mov	C,ACC.5		; 
ti04:
	mov	Kontr,C		;  
	cpl	C
	mov	Kontr0,C

;   
	mov	A,PTB		; 
	anl	A,Cnl_Period	;  
	jnz	ti05		;     
	mov	A,Cnl_Povtor	;   
	jz	ti06		; 
	dec	A
	jz	ti05		;-   - 
ti06:	
				;Cnl_BufLng	;    
				;Cnl_BufSt	;     
				;Cnl_Bufer	;     
	push	Reg0
	mov	R0,Cnl_BufSt	;     , 
	mov	A,@R0		;    Cnl_BufSt
	pop	Reg0
	jb	bWork,ti07	;1 -  , 0 - 
	clr	A		;  (   )
ti07:	mov	P2,A

	inc	Cnl_BufSt	;      
	mov	A,Cnl_BufSt	;    ( Cnl_BufLng)
	add	A,#(-Cnl_Bufer)
	cjne	A,Cnl_BufLng,ti05
	mov	Cnl_BufSt,#Cnl_Bufer

	mov	A,Cnl_Povtor	;   
	jz	ti05		; 
	dec	A
	jz	ti05		;-   - 
	mov	Cnl_Povtor,A	;   

ti05:
	pop     PSW
        pop     ACC
        RETI

;***************************************************
;      
;***************************************************
Serial: push    ACC
        push    PSW

        jnb     RI,ser0     	; 
        clr     RI          	; 

        mov     A,SBUF      	; 

;--      -  "" 
	cjne	A,#' ',ser1	;""
        ajmp    ser2
ser1:	cjne	A,#0Dh,ser3	;<CR>
        ajmp    ser2
ser3:	cjne	A,#0Ah,ser4	;<LF>
        ajmp    ser2
;--  "  "
	
ser4:	lcall	SetBufRs	;  
        ajmp    ser2

ser0:   clr     TI              ; 
	clr	bTxRdy		; 

ser2:   pop     PSW
        pop     ACC
        reti


;******************************************************
;                    
;******************************************************

;------------------------------------------------------
; 50  ( )
;------------------------------------------------------
Pause50: 
	mov	PTA,#2
	ajmp	pa01
;------------------------------------------------------
; 3  ( )
;------------------------------------------------------
Pause3: mov	PTA,#120
	ajmp	pa01
;------------------------------------------------------
; 1  ( )
;------------------------------------------------------
Pause:	mov	PTA,#40
pa01:	mov	A,PTA
	jnz	pa01
	ret

;------------------------------------------------------
; 3        
;( )
;: C=1 -   -   
;       =0 -  
;------------------------------------------------------
Pause3OK: 
	mov	PTA,#120
pa32:	mov	DPTR,#AdrOK	;   ('OK')
	lcall	CompStr		; 
	jc	pa31		;- ,    - 
	jz	pa33		;  - 
pa31:	mov	A,PTA		; 
	jnz	pa32		;  -  
	setb	C		; 
pa33:	ret

;------------------------------------------------------
; 50  (  ) T=0,8
;------------------------------------------------------
Nop50:  mov	R3,#58		;58  -  50
np01:	mov	R4,#0
np02:	nop			;4  256 
	nop			; 858 
	djnz	R4,np02
	djnz	R3,np01
	ret

;------------------------------------------------------
;    ()     
;------------------------------------------------------
SetBufRs:
	mov	R1,iBufRs	; 
	mov	@R1,A		;  ( )
	inc	iBufRs
	mov	R1,iBufRs
	cjne	R1,#(BufRs+BufRsLng),sb1
;   -    ( )
	mov	R1,#(BufRs+1)
sb2:	mov	A,@R1
	dec	R1
	mov	@R1,A
	inc	R1
	inc	R1
	cjne	R1,#(BufRs+BufRsLng+1),sb2
	mov	iBufRs,#(BufRs+BufRsLng-1)	;  

	dec	oBufRs		;  
	mov	R1,oBufRs
	cjne	R1,#(BufRs-1),sb1
	inc	oBufRs	
sb1:	
	ret

;------------------------------------------------------
;        ( )
;  =0,     
;------------------------------------------------------
GetBufRs:
	push	Reg0
	clr	ES		;  .
	mov	R0,oBufRs	; 
	mov	A,@R0
	jz	gb1		;  - 
	inc	oBufRs		; -  
gb1:	
	setb	ES		; 
	pop	Reg0
	ret

;------------------------------------------------------
;    (  
;   ( 0))
;------------------------------------------------------
ResBufRs:
	push	Reg0
	clr	ES		;  .
	mov	iBufRs,#BufRs	;   
	mov	oBufRs,#BufRs	;   
	mov	R0,iBufRs	; 
rb1:	mov	@R0,#0		;0   ( )
	inc	R0
	cjne	R0,#(BufRs+BufRsLng+1),rb1
	setb	ES
	pop	Reg0
	ret

;------------------------------------------------------
;      DPTR   0
;------------------------------------------------------
StrTX:	clr	A
	movc	A,@A+DPTR	;   
	jz	st03		;
	lcall	ByteTX		; 
	inc	DPTR
	ajmp	StrTX		;  - 
st03:	;lcall	ClrBuf		;  	
	ret

;------------------------------------------------------
;  ( )   
;------------------------------------------------------
ByteTX:	jb	bTxRdy,ByteTX	;  
	;       (5 )
;	mov	R5,#40
;btx1:	cjne	R5,#0,btx1	; 2
	mov	SBUF,A		; 
	setb	bTxRdy		; 
	ret
		
;------------------------------------------------------
;      DPTR   0
;     
;  DPTR      ( )
;------------------------------------------------------
ScrStr:
	push	DPH
	push	DPL
	mov	DPTR,#sATCK	; AT+CKPD= 
	lcall	StrTX		;   AT...
	pop	DPL
	pop	DPH
	lcall	StrTX		;   
	mov	A,#0Dh
	lcall	ByteTX
	lcall	ResBufRs	;  
	lcall	Pause3OK	;  OK  3 
	lcall	Pause50		; 50    
	ret
		
;------------------------------------------------------
;    
;     
;  DPTR      ( )
; :  = 0 -   
;'0'..'9' -   
;'#','*','[',']','S','E' -  #,*,,,,
;'^','V','>','<' -   ,,, 
;------------------------------------------------------
ReadKey:
	mov	DPTR,#k_0	;   ('0')
	lcall	CompStr		; 
	jc	not0		;- ,    - 
	jnz	rk_NO		
	;  - 
	mov	A,#'0'		; "0"
	ret
rk_NO:
	clr	A			; 
	ret
not0:
	mov	DPTR,#k_1	;   ('1')
	lcall	CompStr		; 
	jc	not1		;- ,    - 
	;  - 
	mov	A,#'1'		; "1"
	ret
not1:
	mov	DPTR,#k_2	;   ('2')
	lcall	CompStr		; 
	jc	not2		;- ,    - 
	;  - 
	mov	A,#'2'		; "2"
	ret
not2:
	mov	DPTR,#k_3	;   ('3')
	lcall	CompStr		; 
	jc	not3		;- ,    - 
	;  - 
	mov	A,#'3'		; "3"
	ret
not3:
	mov	DPTR,#k_4	;   ('4')
	lcall	CompStr		; 
	jc	not4		;- ,    - 
	;  - 
	mov	A,#'4'		; "4"
	ret
not4:
	mov	DPTR,#k_5	;   ('5')
	lcall	CompStr		; 
	jc	not5		;- ,    - 
	;  - 
	mov	A,#'5'		; "5"
	ret
not5:
	mov	DPTR,#k_6	;   ('6')
	lcall	CompStr		; 
	jc	not6		;- ,    - 
	;  - 
	mov	A,#'6'		; "6"
	ret
not6:
	mov	DPTR,#k_7	;   ('7')
	lcall	CompStr		; 
	jc	not7		;- ,    - 
	;  - 
	mov	A,#'7'		; "7"
	ret
not7:
	mov	DPTR,#k_8	;   ('8')
	lcall	CompStr		; 
	jc	not8		;- ,    - 
	;  - 
	mov	A,#'8'		; "8"
	ret
not8:
	mov	DPTR,#k_9	;   ('9')
	lcall	CompStr		; 
	jc	not9		;- ,    - 
	;  - 
	mov	A,#'9'		; "9"
	ret
not9:
	mov	DPTR,#k_str	;   ('*')
	lcall	CompStr		; 
	jc	notstr		;- ,    - 
	;  - 
	mov	A,#'*'		; "*"
	ret
notstr:
	mov	DPTR,#k_dez	;   ('#')
	lcall	CompStr		; 
	jc	notdez		;- ,    - 
	;  - 
	mov	A,#'#'		; "#"
	ret
notdez:
	clr	A		; 
	ret

k_0:	db	'+CKEV:"0",1',0	; "0"
k_1:	db	'+CKEV:"1",1',0	; "1"
k_2:	db	'+CKEV:"2",1',0	; "2"
k_3:	db	'+CKEV:"3",1',0	; "3"
k_4:	db	'+CKEV:"4",1',0	; "4"
k_5:	db	'+CKEV:"5",1',0	; "5"
k_6:	db	'+CKEV:"6",1',0	; "6"
k_7:	db	'+CKEV:"7",1',0	; "7"
k_8:	db	'+CKEV:"8",1',0	; "8"
k_9:	db	'+CKEV:"9",1',0	; "9"
k_str:	db	'+CKEV:"*",1',0	; "*"
k_dez:	db	'+CKEV:"#",1',0	; "#"
		
;------------------------------------------------------
;  ( ,   )
;:  DPTR -      (0-)
;: C=1      - - ,   
;	=0,=0  -   (R0 . .)
;	=0,<>0 -   (  )
;------------------------------------------------------
CompStr: 
	mov	R0,#BufRs	; 
CompStrR0:			;     R0
	mov	R3,#0		;    
cs01:	mov	A,@R0		;   
	jz	cs02		;  (0) - 
	mov	A,R3
	movc	A,@A+DPTR	;   
	xrl	A,@R0		;   
	jnz	cs03		; 
	inc	R3		; -  
	mov	A,R3
	movc	A,@A+DPTR	;    ( 0 - )
	clr	C		; 
	jz	cs04		; - 
	inc	R0		;   
	ajmp	cs01		;
cs03:	inc	R0		;   
	mov	R3,#0		;     
	ajmp	cs01		;
cs02:	mov	A,R0		;,    
	add	A,#(-BufRs-1)	;   (R0>BufSR)
cs04:	ret

;----------------------------------------------------------------
;   ASCII @R0     
;  R0+2 (  2)
;----------------------------------------------------------------
Asc2bin:
	mov	A,@R0		;  ASCII ()
	anl	A,#00001111b	; 
	rl	A		;  2
	mov	R2,A		; 
	rl	A
	rl	A		;  8
	add	A,R2		;     10
	mov	R2,A		; 
	inc	R0		;  ()
	mov	A,@R0		;  ASCII ()
	anl	A,#00001111b	; 
	add	A,R2		;  
	inc	R0		;  
	ret

;------------------------------------------------------
;        (1..8)
;     
;(8->0FFh=6s,..,4->0Fh=400ms,..,1->1=50ms)
;------------------------------------------------------
SetPeriod:
	anl	A,#0Fh		; .
	mov	R2,A		;  
	clr	A		;ACC=0
sp01:	setb	C		;CY=1
	rlc	A		;  1
	djnz	R2,sp01
	mov	Cnl_Period,A 	;     (0FFh=6s,..,0Fh=400ms,..,1=50ms)
	ret

;------------------------------------------------------
;  ()    (R6)  HEX 
;------------------------------------------------------
Mov2Buf:
	push	Reg0
	mov	R2,A		;
	mov	A,R6		;   R6
	mov	R0,A
	mov	A,R2
	jnb	ACC.6,mb_1	;  
	add	A,#9		;   9
mb_1:	mov	@R0,A
	inc	R6
	pop	Reg0
	inc	R0		;  -
	ret

;******************************************************
;                  
;******************************************************
Begin:  mov     SP,#Steck       ; 
;-------------   -------------
        mov     SCON,#01110000b ;    1
	mov	P2,#01		;(1)  0,  .  0 ()
;-------------  ------------
        MOV     TMOD,#00100001b ;  :
        ;T/C0:      TR0
        ;      16  /
        ;T/C1:      TR1
        ;      8   /
	;         . 1200
	;           52 
        mov     TH1,#194        ;  52 
        mov     TL1,#194	;14.3
	mov	PCON,#10000000b	;SMOD=1
        MOV     TH0,#8BH        ;  T/C0 = 25
        MOV     TL0,#7AH        ;25 ms  (8B7Ah)  14,31818
	mov	PTB,#1		;  -    
        SETB    TR1             ; T/C1
        SETB    TR0             ; T/C0
        SETB    PT1             ; T/C1
        MOV     IE,#00011010b   ;   T/C0  /1  .

	mov	Cnl_Period,#0Fh ;     (0FFh=6s,..,0Fh=400ms,..,1=50ms)
	mov	Cnl_Povtor,#0	;       (0 -  , 1 - )
	mov	Cnl_BufSt,#Cnl_Bufer	;     
					;       
	mov	Cnl_BufLng,#4		;    
	mov	Cnl_Bufer,  #00001000b	;   (    )
	mov	Cnl_Bufer+1,#00000100b
	mov	Cnl_Bufer+2,#00000010b
	mov	Cnl_Bufer+3,#00000001b
	setb	bWork		;1 -  , 0 - 

	clr	bTxRdy		;  ()
	lcall	ResBufRs	;  
		
	mov	Reg_VD,#2	; 
    	SETB    EA          	; 
;
;==============================================================
;     ATZ      
	mov	DPTR,#sATZ	; ATZ (     )
	lcall	StrTX		;   ATZ
	lcall	ResBufRs	;  
	lcall	Pause3		;  3 
	
;==============================================================
;  -  :    ATZ      
	mov	DPTR,#sATZ	; ATZ (     )
	lcall	StrTX		;   ATZ
	lcall	ResBufRs	;  
	lcall	Pause3OK	;  OK  3 
	jnc	bg_0
	ljmp	bg		; ,   -  
bg_0:	lcall	Pause50		; 50    
	
;==============================================================
;   ATE0   -
	mov	DPTR,#sATE0	; ATE0 
	lcall	StrTX		;   AT...
	lcall	ResBufRs	;  
	lcall	Pause3OK	;  OK  3 
	lcall	Pause50		; 50    
				;   	
;==============================================================
;   AT+CMEC=2	;  
	mov	DPTR,#sATCM	; AT+CMEC=2 
	lcall	StrTX		;   AT...
	lcall	ResBufRs	;  
	lcall	Pause3OK	;  OK  3 
	lcall	Pause50		; 50    
				;   	
;==============================================================
;   AT+CMER=3,2,0,0,0	;   
	mov	DPTR,#sATER	; AT+CMER=3,2,0,0,0 
	lcall	StrTX		;   AT...
	lcall	ResBufRs	;  
	lcall	Pause3OK	;  OK  3 
	lcall	Pause50		; 50    
				;   	

;   
; 
;  
	mov	Reg_VD,#3	; 
;     "*< >*"
	mov	DPTR,#s2st	;   c  
	lcall	ScrStr		;   

;    SIM       2
;==========   AT+CPBR (     1) ============
	mov	R7,#('1')	; 1
press_key:
	mov	DPTR,#sCPBRX	;    
	lcall	StrTX		;   +CPBR=1
	mov	A,R7		;  (ASCII)
	lcall	ByteTX
	mov	A,#0Dh
	lcall	ByteTX
	lcall	ResBufRs	;  

	lcall	Pause3OK	;  3  (    )
	lcall	Pause50		; 50    
	mov	DPTR,#AdrStar	;   ('*')  
	lcall	CompStr		; 
	jc	bg03		;- ,   
	jnz	bg_		;  -   
;   -    (1..8) -  
	inc	R0		;    
	mov	A,@R0		; 
;	cjne	@R0,#('.'),bg_1	; ,  
	lcall	SetPeriod	;     
	inc	R0		;     
	lcall	Asc2bin		;   - .2  -
	mov	Cnl_Povtor,A 	;       @R0,@R0+1 (0..99)
	mov	R6,#Cnl_Bufer	;  
bg_5:	mov	A,@R0		;
	cjne	A,#('"'),bg_2	;   
	ajmp	bg_end_p	;  
bg_2:	cjne	A,#('.'),bg_3	;  
	ajmp	bg_end		;
bg_3:	cjne	A,#('-'),bg_4	;     
	ajmp	bg_end_p	;  
bg_4:	lcall	Mov2Buf		;    	
	cjne	R6,#07Fh,bg_5	; 
	ajmp	bg_end		;   
bg_:	ljmp	bg		; 

bg03:	;      -   
	inc	R7		;
	cjne	R7,#('9'+1),pk
	mov	R7,#('1')	;   9- 
pk:	ljmp	press_key	;       SIM
		
;      
bg_end_p:
;==========   AT+CPBR (     2) ============
	inc	R7		;
	cjne	R7,#('9'+1),bep1
	mov	R7,#('1')	;   9- 
	ljmp	bg_end
bep1:	mov	DPTR,#sCPBRX	;    
	lcall	StrTX		;   +CPBR=2
	mov	A,R7		;  (ASCII)
	lcall	ByteTX
	mov	A,#0Dh
	lcall	ByteTX
	lcall	ResBufRs	;  

	lcall	Pause3OK	;  3  (    )
	lcall	Pause50		; 50    
	mov	DPTR,#AdrEqul	;   ('=')  
	lcall	CompStr		; 
	jc	bg_end		;- ,   
	jnz	bg_end		;  -     
;   -     
	inc	R0		;    
				; R6 -       
bg_51:	mov	A,@R0		;
	cjne	A,#('"'),bg_21	;   
	ajmp	bg_end_p1	;   
bg_21:	cjne	A,#('.'),bg_31	;  
	ajmp	bg_end		;
bg_31:	cjne	A,#('-'),bg_41	;     
	ajmp	bg_end_p1	;   
bg_41:	lcall	Mov2Buf		;    	
	cjne	R6,#07Fh,bg_51	; 
	ajmp	bg_end		;   

;       (  -  40  )
bg_end_p1:
;==========   AT+CPBR (     3) ============
	inc	R7		;
	cjne	R7,#('9'+1),bep2
	mov	R7,#('1')	;   9- 
	ljmp	bg_end
bep2:	mov	DPTR,#sCPBRX	;    
	lcall	StrTX		;   +CPBR=3
	mov	A,R7		;  (ASCII)
	lcall	ByteTX
	mov	A,#0Dh
	lcall	ByteTX
	lcall	ResBufRs	;  

	lcall	Pause3OK	;  3  (    )
	lcall	Pause50		; 50    
	mov	DPTR,#AdrEqul	;   ('=')  
	lcall	CompStr		; 
	jc	bg_end		;- ,   
	jnz	bg_end		;  -     
;   -     
	inc	R0		;    
				; R6 -       
bg_52:	mov	A,@R0		;
	cjne	A,#('"'),bg_22	;   
	ajmp	bg_end		;  
bg_22:	cjne	A,#('.'),bg_32	;  
	ajmp	bg_end		;
bg_32:	cjne	A,#('-'),bg_42	;     
	ajmp	bg_end 		; 
bg_42:	lcall	Mov2Buf		;    	
	cjne	R6,#07Fh,bg_52	; 
	ajmp	bg_end		;   

bg_end:
;    
	mov	Cnl_BufSt,#Cnl_Bufer	;     
					;       
	mov	A,R6			; 
	add	A,#(-Cnl_Bufer)		;
	mov	Cnl_BufLng,A		;    

bg:					;        
	
cyr:					;  
;    
	jnb	KeyPin,c_pr	; 
	jb	KeyOld,c_en	;   -  
	;  
	setb 	KeyOld		;  
	mov	DPTR,#s_1	; "#1" 
	lcall	ScrStr		;   
	ajmp	c_en
	
c_pr:
	jnb	KeyOld,c_en	;   - 
	;  
	clr 	KeyOld		;  
	mov	DPTR,#s_2	; "#2" 
	lcall	ScrStr		;   
	
c_en:
;    
	lcall	ReadKey		;    
	
	cjne	A,#'1',c_k1	;  "1" -  
	mov	Reg_VD,#1	; 
	mov	R7,#('1')	;  
;	setb	Cnl_0		;  0
	ajmp	c_k3
	
c_k1:	
	cjne	A,#'2',c_k2	;  "2" -  
	mov	Reg_VD,#2	; 
	mov	R7,#('2')	;  
;	setb	Cnl_1		;  1
	ajmp	c_k3
	
c_k2:	
	cjne	A,#'3',c_k41	;  "3" -  
	mov	Reg_VD,#3	; 
	mov	R7,#('3')	;  
;	setb	Cnl_2		;  2
	ajmp	c_k3
	
c_k41:	
	cjne	A,#'4',c_k42	;  "4" -  
	mov	Reg_VD,#3	; 
	mov	R7,#('4')	;  
;	setb	Cnl_3		;  3
	ajmp	c_k3
	
c_k42:	
	cjne	A,#'5',c_k43	;  "5" -  
	mov	Reg_VD,#3	; 
	mov	R7,#('5')	;  
	ajmp	c_k3

c_k43:	
	cjne	A,#'6',c_k44	;  "6" -  
	mov	Reg_VD,#3	; 
	mov	R7,#('6')	;  
	ajmp	c_k3

c_k44:	
	cjne	A,#'7',c_k45	;  "5" -  
	mov	Reg_VD,#3	; 
	mov	R7,#('7')	;  
	ajmp	c_k3

c_k45:	
	cjne	A,#'8',c_k46	;  "8" -  
	mov	Reg_VD,#3	; 
	mov	R7,#('8')	;  
	ajmp	c_k3

c_k46:	
	cjne	A,#'9',c_k47	;  "9" -  
	mov	Reg_VD,#3	; 
	mov	R7,#('9')	;  
	ajmp	c_k3


c_k47:	
	cjne	A,#'0',c_k4	;  "0" -  
	mov	Reg_VD,#2	; 
	mov	P2,#0		;  
	lcall	ResBufRs	;  
c_k4:
	mov	A,Cnl_Povtor	;       (0 -  , 1 - )
	cjne	A,#1,c_k99
				;  -     
	inc	R7		;
	cjne	R7,#('9'+1),c_k98
	mov	R7,#('1')	;   9- 
c_k98:	ljmp	press_key

c_k99:	
;    (  /)
	mov	DPTR,#AdrRING	;   (RING)
	lcall	CompStr		; 
	jc	c_k97		;- ,   
	jnz	c_k97		; 
;  -   ( ,  ) -     
	mov	Reg_VD,#1	; 
	mov	DPTR,#sATH	;  ( ATH)
	lcall	StrTX		;   
	lcall	ResBufRs	;  
	cpl	bWork		;1 -  , 0 - 

c_k97:
	ljmp	cyr

c_k3:
	lcall	ResBufRs	;  
	ljmp	press_key
	
        END
;

